Subject: Re: [RFC v1 for accelerated IPoIB 05/25] IB/ipoib: Support ipoib acceleration options callbacks

From: Leon Romanovsky <leonro-VPRAkNaXOzVWk0Htik3J/[email-masked]>
Date: Wed, 15 Mar 2017 19:39:06 +0200

On Wed, Mar 15, 2017 at 09:58:02AM -0600, Jason Gunthorpe wrote:
> On Wed, Mar 15, 2017 at 08:47:51AM +0200, Leon Romanovsky wrote:
> > On Tue, Mar 14, 2017 at 10:00:21AM -0600, Jason Gunthorpe wrote:
> > > On Tue, Mar 14, 2017 at 04:42:55PM +0200, Erez Shitrit wrote:
> > > > >> +       if (!hca->alloc_rdma_netdev)
> > > > >> +               dev = ipoib_create_netdev_default(hca, name,
> > > > >> ipoib_setup_common);
> > > > >> +       else
> > > > >> +               dev = hca->alloc_rdma_netdev(hca, port, RDMA_NETDEV_IPOIB,
> > > > >> +                                            name, NET_NAME_UNKNOWN,
> > > > >> +                                            ipoib_setup_common);
> > > > >> +       if (!dev) {
> > > > >> +               kfree(priv);
> > > > >> +               return NULL;
> > > > >> +       }
> > > > >
> > > > >
> > > > > This will break ipoib on hfi1 as hfi1 will define alloc_rdma_netdev for
> > > > > OPA_VNIC type. We should probably look for a dedicated return type
> > > > > (-ENODEV?) to determine of the driver supports specified rdma netdev type.
> > > > > Or use a ib device attribute to suggest driver support ipoib rdma netdev.
> > > >
> > > > sorry, I don't understand that, we are in ipoib driver, so the type is
> > > > RDMA_NETDEV_IPOIB, if hfi wants to implement it should use the same
> > > > flag, and to use OPA_VNIC for vnic.
> > >
> > > He means it should look like this:
> > >
> > >  if (hca->alloc_rdma_netdev)
> > >      dev = hca->alloc_rdma_netdev(hca, port, RDMA_NETDEV_IPOIB,
> > >                                             name, NET_NAME_UNKNOWN,
> > >                                             ipoib_setup_common);
> > >
> > >  if (IS_ERR(dev) && PTR_ERR(dev) != ENOTSUP)
> > >       goto out;
> > >
> > >  dev = ipoib_create_netdev_default(hca, name, ipoib_setup_common);
> > >  if (IS_ERR(dev))
> > >       goto out;
> > >
> > >  WARN_ON(dev == NULL);
> > >
> > >   [...]
> > >
> > > out:
> > >       return PTR_ERR(dev);
> > >
> > > And I'm confused why 'ipoib_create_netdev_default' doesn't need the
> > > same function signature as hca->alloc_rdma_netdev
> >
> > And now, I'm confused.
> > In your's proposal, the "dev" will be overwritten, in Erez's proposal,
> > "dev" will be one of two: defaults or device specific.
>
> Well, not Erez's version allowed dev to be ERR_PTR too. More like this then
>
> struct rdma_netdev *get_netdev(..)
> {
>    if (hca-alloc_rdma_netdev) {
>        dev = hca-alloc_rdma_netdev(hca, port, RDMA_NETDEV_IPOIB,
>                                               name, NET_NAME_UNKNOWN,
>                                               ipoib_setup_common);
>
>        if (!IS_ERR(dev) || PTR_ERR(dev) != ENOTSUP)
>            return dev;
>    }
>
>    return ipoib_create_netdev_default(hca, name, ipoib_setup_common);
> }

Thanks, I agree with you, the interfaces should properly handle errors
paths from day one.

>
> Jason
> --
> To unsubscribe from this list: send the line "unsubscribe linux-rdma" in
> the body of a message to [email-masked]
> More majordomo info at  http://vger.kernel.org/majordomo-info.html